田草博客

互联网田草博客


网友交流QQ群:11740834 需注明申请加入原因

微信 公众号:ByCAD

邮箱:tiancao1001x126.com
ByCAD,微信公众号
首页 | 普通 | 电脑 | AutoCAD | VB/VB.NET | FLash | 结构 | 建筑 | 电影 | BIM | 规范 | 软件 | ID
-随机-|-分布-
-博客论坛-|-﨣﨤﨧﨨-
-网站导航-|-规范下载-
-BelovedFLash欣赏-

用户登陆
用户:
密码:
 

站点日历
73 2024 - 3 48
     12
3456789
10111213141516
17181920212223
24252627282930
31


站点统计

最新评论



how to get preview dwg without autocad ? Visual Basic.NET二次开发AutoCAD范例
未知 绘制自定义多线   [ 日期:2010-11-24 ]   [ 来自:转帖 ]  HTML
这段代码来自 Kean Walmsley @ Through-The-Interface


仅仅做一点小小修改

    '绘制自定义多线
    <CommandMethod("MYPOLY")> _
    Public Sub MyPoly()
        Dim doc As Document = Application.DocumentManager.MdiActiveDocument
        Dim db As Database = doc.Database
        Dim ed As Editor = doc.Editor
        Dim col As Color = doc.Database.Cecolor
        Dim pts As New Point3dCollection()
        Dim opt As New PromptPointOptions(vbLf & "Select polyline vertex: ")
        opt.AllowNone = True
        Dim res As PromptPointResult = ed.GetPoint(opt)
        While res.Status = PromptStatus.OK
            pts.Add(res.Value)
            opt.UseBasePoint = True
            opt.BasePoint = res.Value
            res = ed.GetPoint(opt)
            If res.Status = PromptStatus.OK Then
                ed.DrawVector(pts(pts.Count - 1), res.Value, col.ColorIndex, False)
            End If
        End While
        If res.Status = PromptStatus.None Then
            Dim ucs As Matrix3d = ed.CurrentUserCoordinateSystem
            Dim origin As New Point3d(0, 0, 0)
            Dim normal As New Vector3d(0, 0, 1)
            normal = normal.TransformBy(ucs)
            Dim plane As New Plane(origin, normal)
            Dim pline As New Polyline(pts.Count)
            pline.Normal = normal
            For Each pt As Point3d In pts
                Dim transformedPt As Point3d = pt.TransformBy(ucs)
                pline.AddVertexAt(pline.NumberOfVertices, plane.ParameterOf(transformedPt), 0, 0, 0)
            Next
            Using tr As Transaction = db.TransactionManager.StartTransaction()
                Dim bt As BlockTable = DirectCast(tr.GetObject(db.BlockTableId, OpenMode.ForRead), BlockTable)
                Dim btr As BlockTableRecord = DirectCast(tr.GetObject(bt(BlockTableRecord.ModelSpace), OpenMode.ForWrite), BlockTableRecord)
                Dim plineId As ObjectId = btr.AppendEntity(pline)
                tr.AddNewlyCreatedDBObject(pline, True)
                For Each ent As Entity In pline.GetOffsetCurves(-44.7)
                    btr.AppendEntity(ent)
                    tr.AddNewlyCreatedDBObject(ent, True)
                Next
                For Each ent As Entity In pline.GetOffsetCurves(-51)
                    btr.AppendEntity(ent)
                    tr.AddNewlyCreatedDBObject(ent, True)
                Next
                tr.Commit()
            End Using
        End If
    End Sub


[本日志由 tiancao1001 于 2010-11-25 04:30 PM 编辑]


暂时没有评论
发表评论 - 不要忘了输入验证码哦!
作者: 用户:  密码:   注册? 验证:  防止恶意留言请输入问题答案:2*5=?  
评论:

禁止表情
禁止UBB
禁止图片
识别链接
识别关键字

字体样式 文字大小 文字颜色
插入粗体文本 插入斜体文本 插入下划线
左对齐 居中对齐 右对齐
插入超级链接 插入邮件地址 插入图像
插入 Flash 插入代码 插入引用
插入列表 插入音频文件 插入视频文件
插入缩进符合
点击下载按钮 下标 上标
水平线 简介分割标记
表  情
 
Tiancao Blog All Rights Reserved 田草博客 版权所有
Copyright ©